=== debian/changelog ===
device-tree-compiler (1.7.2-2build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 11:55:39 +0100

device-tree-compiler (1.7.2-2) unstable; urgency=medium

  * debian/rules: Only use valgrind in tests when valgrind is present.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 23 Dec 2024 23:22:34 -0800

device-tree-compiler (1.7.2-1) unstable; urgency=medium

  * New upstream release (Closes: #1091118)
  * debian/upstream: Update signing key.
  * debian/copyright: Update for 1.7.2.
  * debian/control: Switch to pkgconf.
  * debian/patches: Add upstream patch fixing build with various SWIG
    versions. Thanks to Florian Ernst.
  * debian/patches: Drop patch for Python 3.12, no longer needed.  Thanks
    to Florian Ernst.
  * debian/libfdt1.install: Adjust for new .so file names. Thanks to
    Florian Ernst.
  * debian/control: Update to Standards-Version 4.7.0.
  * debian/rules: Make test suite more verbose and use default flags.

 -- Vagrant Cascadian <vagrant@debian.org>  Mon, 23 Dec 2024 18:11:03 -0800
