=== debian/control ===
Source: device-tree-compiler
Section: devel
Priority: optional
Maintainer: Héctor Orón Martínez <zumbi@debian.org>
Uploaders: Vagrant Cascadian <vagrant@debian.org>
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13),
 dh-python,
 flex,
 bison,
 libyaml-dev,
 pkgconf,
 python3-dev,
 python3-setuptools,
 python3-setuptools-scm,
 swig,
 texlive <!nodoc>,
 texlive-latex-extra <!nodoc>,
 valgrind [amd64 arm64 armhf i386 mips mips64el mipsel powerpc ppc64 ppc64el s390x],
Rules-Requires-Root: no
Homepage: https://git.kernel.org/cgit/utils/dtc/dtc.git
Vcs-Git: https://salsa.debian.org/crosstoolchain-team/device-tree-compiler.git
Vcs-Browser: https://salsa.debian.org/crosstoolchain-team/device-tree-compiler

Package: device-tree-compiler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: foreign
Description: Device Tree Compiler for Flat Device Trees
 Device Tree Compiler, dtc, takes as input a device-tree in
 a given format and outputs a device-tree in another format
 for booting kernels on embedded systems.
 .
 Typically, the input format is "dts", a human readable source
 format, and creates a "dtb", or binary format as output.

Package: libfdt1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Flat Device Trees manipulation library
 This is a library containing functions for manipulating Flat Device Trees.

Package: libfdt-dev
Architecture: any
Section: libdevel
Depends: libfdt1 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Flat Device Trees manipulation library - development files
 This is a library containing functions for manipulating Flat Device Trees.
 .
 This package contains the files needed for development against libfdt.

Package: python3-libfdt
Architecture: any
Section: python
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${python3:Provides}
Description: Flat Device Trees manipulation library - Python bindings
 This is a library containing functions for manipulating Flat Device Trees.
 .
 This package contains the files needed for Python development with libfdt.
